//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_buffers 2
#property indicator_color1 LawnGreen
#property indicator_width1 2
#property indicator_color2 Red
#property indicator_width2 2

extern string EmaPeriods = "1,12;2,24;3,36";

double GreenBuffer[];
double RedBuffer[];
double trend[];
double periods[][2];
int    size;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,GreenBuffer); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,RedBuffer);   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,trend);

      //
      //
      //
      //
      //
         
      if (StringSubstr(EmaPeriods,StringLen(EmaPeriods)-1,1) != ";")
                       EmaPeriods = StringConcatenate(EmaPeriods,";");
         int    s = 0;
         int    i = StringFind(EmaPeriods,";",s);
         string current;
            while (i > 0)
            {
               current = StringSubstr(EmaPeriods,s,i-s);
                     ArrayResize(periods,ArrayRange(periods,0)+1);
                                 int k = StringFind(current,",");
                                 periods[ArrayRange(periods,0)-1][0] = StrToDouble(StringSubstr(current,0,k));
                                 periods[ArrayRange(periods,0)-1][1] = StrToDouble(StringSubstr(current,k+1,0));
                                 s = i + 1;
                                     i = StringFind(EmaPeriods,";",s);
            }
         size = ArrayRange(periods,0);
   
      //
      //
      //
      //
      //
   
   IndicatorShortName(size+" EMA crossovers");
   return(0);
}
int deinit(){ return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
  {
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {
      int count = 0;
      for (int k=0; k<size; k++)
      {
         double macd = iMACD(NULL,0,periods[k][0],periods[k][1],1,PRICE_CLOSE,MODE_MAIN,i);
         if (macd>0) count++;
         if (macd<0) count--;
      }         
      GreenBuffer[i] = EMPTY_VALUE;
      RedBuffer[i]   = EMPTY_VALUE;
      trend[i]        = trend[i+1];
      if (count== size) trend[i] =  1;
      if (count==-size) trend[i] = -1;
      if (trend[i] ==  1) GreenBuffer[i] = 100;
      if (trend[i] == -1) RedBuffer[i]   = 100;
   }
   return(0);
}